/**************************************************************
****** FUNCTIONS FOR SD RAW DATA TRANSFER *******
**************************************************************
Controller: ATmega32 (8 Mhz internal)
Compiler	: AVR-GCC
Version	: 2.2
Author	: CC Dharmani, Chennai (India)
			  www.dharmanitech.com
Date		: 15 July 2009
**************************************************************/

/*======================================================
modifie par Silicium628 (France)
Un grand merci à CC Dharmani pour l'ensemble de son travail!
15 octobre 2009
http://silicium628.chez-alice.fr/
http://www.silicium628.fr/
========================================================*/


#ifndef _SD_ROUTINES_H_
#define _SD_ROUTINES_H_

//Use following macro if you don't want to activate the multiple block access functions
//those functions are not required for FAT32

#define FAT_TESTING_ONLY         

//use following macros if SS (PB4) pin is used for Chip Select of SD
#define SD_CS_ASSERT     PORTB &= 0b11101111
#define SD_CS_DEASSERT   PORTB |= 0b00010000

#define GO_IDLE_STATE            0
#define SEND_OP_COND             1
#define SEND_CSD                 9
#define STOP_TRANSMISSION        12
#define SEND_STATUS              13
#define SET_BLOCK_LEN            16
#define READ_SINGLE_BLOCK        17

#define CRC_ON_OFF               59

#define ON     1
#define OFF    0

volatile uint32_t startBlock, totalBlocks; 
volatile uint8_t buffer[512];
volatile uint8_t str_lu[40]; 

uint8_t SD_init(void);
uint8_t SD_sendCommand(uint8_t cmd, uint32_t arg);
uint8_t SD_readSingleBlock(uint32_t startBlock);


#endif
